// Soubor POLE1.CPP
// Pklad tdy obsahujc dynamicky alokovan pole
// koprovac konstruktor a destruktor
// Verze 1 - nic moc: chyb piazovac opertor,
// dlka pole je deklarovna pomoc globln konstanty

// Vzhledem k rozdlm v chovn peklada
// zde nekontrolujeme, zda se alokace podaila,
// take pklad lze peloit i starmi pekladai

const int N = 10;		// Dlka pole
class pole {
	int *p;
public:
	explicit pole(int d=0);
	pole(pole&);		// koprovac konstruktor
	int &prvek(int i) { return p[i]; }
	~pole() { delete p;}	// destruktor
};

pole::pole(int d)
{
	p = new int [N];
	for(int i = 0; i < N; i++)
		p[i] = d;
}

pole::pole(pole& P)
{
	p = new int[N];
	for(int i = 0; i < N; i++) p[i] = P.p[i];
}

void main()
{
  pole P(0);
  P.prvek(1) = 56;
  pole Q(P);
}