// Soubor POLE2.CPP
// Pklad dynamicky alokovanho pole

// Verze 2: dlka pole je popsna vtovm typem 
// deklarovanm uvnit tdy pole

// Vzhledem k rozdlm v chovn peklada
// zde nekontrolujeme, zda se alokace podaila, stejn jako
// ve verzi 1

class pole {
	enum {delka = 10};
	int *p;
public:
	explicit pole(int d=0);
	pole(pole&);
	int &prvek(int i) { return p[i]; }
	~pole() { delete p;}
};

pole::pole(int d)			// Konstruktor alokuje [delka] prvk
{
	p = new int [delka];
	for(int i = 0; i < delka; i++)	// a vypln je hodnotou d
		p[i] = d;
}

pole::pole(pole& P)			// Koprovac konstruktor udl hlubokou kopii
{
	p = new int[dekla];
	for(int i = 0; i < delka; i++) p[i] = P.p[i];
}

void main()
{
  pole P(0);
  P.prvek(1) = 56; 
//  P.prvek(pole::delka - 1) = 45; // chyba - vtov konstanta pole::delka je soukrom
  pole Q(P);
}