// Soubor SEZNAM1.CPP
// Jednosmrn seznam se zarkou (pklad vnoen tdy a statickch sloek)
// nepln implementace, obsahuje pouze:
// * deklaraci typu seznam::prvek (vnoen tdy) - pstup k datm pomoc referennch funkc
// * konstruktor, kter vytvo przdn seznam (obsahujc pouze zarku, tedy pomocn przdn prvek)
// * destruktor, kter uvoln vechny prvky v seznamu
// * metodu VlozNaKonec, kter vytvo nov prvek se zadanmi daty a vlo ho na konec seznamu
// 
// Celkov poet seznam ukazuje soukrom statick datov sloka pocet
// jej hodnotu, tedy celkov poet instanc, vrac veejn statick metoda Pocet()

#include <iostream.h>

// Smn zpsob oetovn chyb
void Chyba() { cout << "CHYBA!!!" << endl; }

typedef int data;  // Typ vkldanch prvk

class seznam {
public:
	class prvek {			// Vnoen tda: prvek seznamu
		data _Data;
		prvek* _dalsi;
	public:
		prvek(data D=0);
		prvek* &Dalsi() {return _dalsi;}
		data & Data() {return _Data;}
	};
	seznam();
	~seznam();
	void VlozNaKonec(data D);
	static int Pocet() {return pocet; }
private:
	prvek *hlava, *zarazka;
	static int pocet; 		// Statick atribut: celkov poet seznam
};

int seznam::pocet = 0;	// Definin deklarace statick sloky

void seznam::VlozNaKonec(data D)
{
	prvek *p = new prvek(0); // Alokujeme nov prvek
	zarazka->Data() = D; // Ulome data do zarky
	zarazka->Dalsi() = p; // a pipojme nov prvek 
	zarazka = p;		// na konec jako novou zarku
}

seznam::seznam()
{
	pocet++;  // Jeden seznam vytvoen - uprav celkov poet seznam
	hlava = new prvek(0);
	zarazka = hlava;
}

seznam::~seznam()
{
	while (hlava != zarazka) // Vyma vechny smyslupln prvky
	{
		prvek *p = hlava;
		hlava = p->Dalsi();
		delete p;
	}
	delete hlava; // a nakonec vyma i zarku
	pocet--;      // Jeden seznam zruen - uprav celkov poet seznam
}

seznam::prvek::prvek(data D)
: _Data(D), _dalsi(0)
{ }

void main()
{
  seznam *S = new seznam;
  if(seznam::Pocet() == 0) Chyba();	// Pouit statick metody
  for(int i = 1; i < 5; i++) S ->VlozNaKonec (i);
  delete S;
}