// Soubor POLE3.CPP
// Pklad petenho opertoru indexovn
// Jde o rozen pkladu ze souboru POLE2.CPP

// Zmny: 
// - nepojmenovan vtov typ je veejn, abychom mohli pouvat
//   konstantu delka i mimo tdu
// - metodu Prvek() nahradil peten opertor []


// Vzhledem k rozdlm v chovn peklada
// zde nekontrolujeme, zda se alokace podaila, stejn jako
// v pedchozch verzch

class pole {
	int *p;
public:
	enum {delka = 10};
	explicit pole(int d=0);
	pole(pole&);
	int& operator[](int);
	~pole() { delete p;}
};

pole::pole(int d)
{
	p = new int [delka];
	for(int i = 0; i < delka; i++)
		p[i] = d;
}

pole::pole(pole& P)
{
	p = new int[delka];
	for(int i = 0; i < delka; i++) p[i] = P.p[i];
}

int& pole::operator [](int index)
{
	return p[index];
}

void main()
{
  pole P(0);
  for(int i = 0; i < pole::delka; i++) // Nyn meme pout pole::delka, nebo tento typ je veejn
	  P[i] = 10;
  pole Q(P);
}