// Soubor PRETYP.CPP
// Opertor petypovn

// Tda string reprezentujc znakov etzec obsahuje pole znak 
// Konstruktor do tohoto pole ulo etzec
// Opertor petypovn na const char* vrt ukazatel na toto pole
// s je instance tdy string
// V pkazu strcpy(ccc, s) se s automaticky konvertuje na const char*
//
#include <string.h>
#include <iostream.h>

class string {
public: 
	enum {delka = 10};
	string(const char* = 0);
	operator const char * ();
private:
	char c[delka+1];	// Navic 1 znak pro koncovou 0
};

string::string(const char* C)
{
	for(int i = 0; i < delka+1; i++) c[i] = 0;
	if(C) {
		int n = strlen(C);
		strncpy(c, C, (n>delka?delka:n));
	}
}

string::operator const char *()
{
	return c;
}

void main(){
  string s("Ahoj lidi tam");
  cout << s << endl;	// Vype "Ahoj lidi "
  char ccc[20];
  strcpy(ccc, s);	// Zde se automaticky pouije n opertor petypovn 
  // char *c = s; // CHYBA - nelze piadit ukazatel na konstantu ukazateli na nekonstantn objekt
  //strcpy(s, ccc); // CHYBA - s nelze konvertovat na char*
  char d = s[1];
  // s[1] = 'u';// CHYBA - chceme mnit konstantn objekt
}