/*
	Soubor GO.H
	Deklarace tdy GO (spolen pedek vech grafickch objekt) 
	a jeho potomk Bod a Usecka
	- Aby sprvn fungovalo ukldn do soubor pomoc opertoru <<,
	  mus kad z nich obsahovat virtuln metodou Uloz(Soubor& s), kter 
	  ulo aktuln instanci do s.
	- Abychom se nemuseli starat o implementan detaily grafickch objekt,
	  vypisuj metody Nakresli() a Smaz() pouze zprvy Kreslm bod..., 
	  Mau bod... apod.
*/

#ifndef _GO_H_
 #define _GO_H_

//#include "soubor.h"

class Soubor;

class GO
{
protected:
 int barva;		// Sloka barva je chrnn, aby s n mohly
public:			// snadno pracovat i odvozen tdy
 GO(int bar): barva(bar){}
 virtual void Nakresli()=0;
 virtual void Smaz()=0;
 virtual Soubor& Uloz(Soubor&);	// Tato metoda bude mt na starosti skuten uloen instance do souboru
 virtual~GO(){ }
};

class Bod: public GO
{
protected:
  int x, y;
public:
  Bod(int bar, int xx, int yy): GO(bar), x(xx), y(yy) {}
  void Nakresli();
  void Smaz();
  Soubor& Uloz(Soubor& s);
  ~Bod(){ Smaz(); }
};

class Usecka: public GO
{
protected:
  int x1,y1,x2,y2;
public:
  Usecka(int bar, int xx1, int yy1, int xx2, int yy2)
  : GO(bar), x1(xx1), y1(yy1), x2(xx2), y2(yy2) {}
  void Nakresli();
  void Smaz();
  Soubor& Uloz(Soubor& s);
  ~Usecka(){ Smaz(); }
};


#endif