// Soubor HLAVNI.CPP
/* Program pedvd "polymorfizmus opertoru vzhledem k pravmu operandu".
   Projekt (kter si muste vytvoit sami, nebo zvis na prosted, kter 
   pouvte) se skld se z tchto soubor:
   - HLAVNI.CPP - hlavn program, ve kterm se pedvdn konstrukce pouij,
   - GO.H a GO.CPP, kter obsahuj definici grafickch objekt (tdy GO, 
	 Bod, Usecka)
   - SOUBOR.H a SOUBOR.CPP, kter obsahuj definici tdy Soubor pro binrn
     ukldn grafickch objekt pomoc opertoru << 
   
   Tento program obsahuje pole g ukazatel na grafick objekty (typ GO*),
   do kterho ulo adresy dvou dynamickch instanc (Bod a Usecka).
   Tyto instance pak ulo do instance tdy Soubor pomoc opertoru <<.
*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "soubor.h"
#include "go.h"

const N = 2;

void main()
{
 Soubor s("data.dta");
 GO *g[N];
 g[0] = new Bod(1,2,3);
 g[1] = new Usecka(0xa, 0xb, 0xc, 0xd, 0xe);
 int i;
 for(i = 0; i < N; i++) g[i] -> Nakresli();
 s.Otevri(Soubor::zapis);
 for(i = 0; i < N; i++) s << *g[i];
 for(i = 0; i < N; i++) delete g[i];
 s.Zavri();
}