// Soubor RTTI1.CPP
// Pklad ukazujc dynamickou identifikaci typ a jej pouit
// pro polymorfn typy, kdy opravdu funguje, 
// a pro nepolymorfn typy, kdy vlastn nefunguje
//
// !!! POZOR: V NKTERCH PEKLADACH JE NUTNO RTTI PEDEM POVOLIT !!!
// !!! V NASTAVENCH PEPNA PEKLADAE, JINAK PROGRAM NEFUNGUJE  !!!
//
// V tto podob obsahuje program dv polymorfn tdy, Alfa a Beta, 
// kter obsahuj virtuln metodu f. Tda Beta je potomkem Alfa.
// V hlavnm programu jsou deklarovny ukazatele p1 a p2 na typ Alfa, 
// Ukazateli p1 je piazena adresa instance typu Alfa, 
// ukazateli p2 piazena adresa instance typu Beta.
// V bloku try nejprve vypeme typ instance, na kter p2 ukazuje,
// pomoc metody name(). Program sprvn vype, e p2 ukazuje na 
// instanci typu Beta. (Tdy jsou polymorfn, RTTI opravdu funguje.)
//
// Pak zmnme direktivu 
// #define VIRTUAL virtual
// na 
// #define VIRTUAL
// a tm zmnme polymorfn tdy na nepolymorfn. RTTI ji nebude fungovat 
// sprvn, pkaz b bloku try vype, e p2 ukazuje na instanci typu Alfa.

#include <typeinfo>
#include <iostream>
using namespace std;
 
#define VIRTUAL virtual		// Zmnou tto direktivy se z polymorfnch td stanou nepolymorfn
class Alfa {
public:
 	VIRTUAL void f() {cout <<"Alfa"<<endl;};
};
class Beta:public Alfa {
public:
 	void f(){ cout << "Beta" << endl;};
};
int main(){
	Alfa p;
	Beta d;
	Alfa *p1= &p, *p2 = &d;
	try{
		cout 	<< "p2 ukazuje na objekt typu "<< typeid(*p2).name() 
					<< endl
					<< 	(typeid(*p1).before(typeid(*p2)) ?
							"Prvni v abecede je objekt, na ktery ukazuje p1" :
							"Prvni v abecede je objekt, na ktery ukazuje p2" ) << endl;
	}
	catch(bad_typeid){
		cout << "Dereferencuje 0" << endl;
		return 1;
	}
	return 0;
}

/*
VSTUP TOHOTO PROGRAMU V DAN PODOB:
p2 ukazuje na objekt typu class Beta
Prvni v abecede je objekt, na ktery ukazuje p1

VSTUP TOHOTO PROGRAMU PO ZMN POLYMORFNCH TD NA NEPOLYMORFN
p2 ukazuje na objekt typu class Alfa
Prvni v abecede je objekt, na ktery ukazuje p2
*/