// Soubor NSP1.CPP
// Soubor NSP1.CPP
// vodn pklad k prostorm jmen
//
// Program ukazuje deklaraci pojmenovanho prostoru jmen,
// pouit globlnch promnnch v prostoru jmen a mimo n
// a definici funkce z prostoru jmen mimo tento prostor jmen

#include <iostream>

// Globln promnn a funkce definovan mimo prostor jmen
int i = 5;
void f()
{
	std::cout << "Globalni funkce" << std::endl;
}

namespace Prvni {
	// Promnn a funkce v prostoru jmen
	int i = 22;
	void f();
}

// Funkci meme definovat i mimo prostor jmen, 
// sta, e je v prostoru jmen deklarace
void Prvni::f(){
	// Tlo tto funkce je soust prostoru jmen Prvni
	// Objekt z jinho prostoru jmen (nap. cout) je teba kvalifikovat
	// objekty z prostoru jmen Prvni nikoli:
	// zde uveden i bez kvalifikace odkazuje na Prvni::i
	// Globln jmno lze pout pomoc unrnho opertoru ::,
	// take ::i je globln i
	std::cout << "Funkce v prostoru Prvni: " << "i*::i = " << i*::i << std::endl;
}

int main()
{
	int i = 555;
	std::cout 	<< "lokalni i = " << i << std::endl;
	std::cout 	<< "Prvni::n = "
					<< Prvni::i << std::endl;
	std::cout 	<< "globalni i = " << ::i << std::endl;
	f();
	Prvni::f();
	return 0;
}
