// Soubor NSP2.CPP
// Vnoen prostor jmen
// Program obsahuje prostor jmen Vnejsi a do nj vnoen prostor jmen Vnoreny
//
// Pouijeme-li identifiktor z vnitnho prostoru jmen 
// - ve vnitnm prostoru, nemusme ho kvalifikovat
// - ve vnjm prostoru, sta ho kvalifikovat jmnem vnitnho prostoru,
// - kdekoli jinde, musme ho kvalifikovat jmnem vnitnho i vnjho prostoru

#include <iostream>
#include<string>

namespace Vnejsi {
	std::string Text = "Vnejsi";
	void Tiskni(){std::cout << Text << std::endl;}
	namespace Vnoreny {			// Vnoen prostor jmen
		std::string Text = "Vnejsi::Vnoreny";
		void Tiskni(){std::cout << Text << std::endl;}
	}							// Konec vnoenho prostoru jmen
	void JesteTiskni() { std::cout << Vnoreny::Text << std::endl;}
}

int main(){
	Vnejsi::Tiskni();
	Vnejsi::Vnoreny::Tiskni();
	Vnejsi::JesteTiskni();
	return 0;
}
