// Soubor IO1.CPP
// Pklad formtovn pi vstupu
//
// Funkce Tab vytiskne tabulku matematick funkce f. Nzev funkce
// (pro tisk) je obsaen v parametru s.
// Funkce ukazuje pouit manipultor setw(n), kter nastavuje ku 
// vstupnho pole, 
// manipultoru fixed, kter pedepisuje formt s pevnou dovou rkou,
// manipultoru setprecision(n), kter pedepisuje poet desetinnch mst
// (je-li dn formt fixed),
// a manipultoru showpoint, kter pedepisuje zobrazovat desetinnou teku vdy.
//
// Pozor: zatmco vtina nastaven pomoc manipultor plat od chvle 
// nastaven do chvle, kdy je njak zrume
// nastaven ky pole pomoc setw(n) plat vdy jen pro nsledujc vstup.

// Doporuuji zkusit mnit nebo odstraovat manipultory
// a pozorovat, co to dl

#include <iomanip>
#include <iostream>
#include <math.h>

using namespace std;

void Tab(const char* s, double (*f)(double))
{
	cout << "Tabulka funkce " << s << endl;
	cout << "-------------------" << endl;
	cout << setw(5) << "x" << setw(8) << s << "(x)" << endl;
	cout << "-------------------" << endl;
	cout << setprecision(5) << fixed << showpoint;
	for(int i = 0; i <= 10; i++)
	{
		double x = i/10.0;
		cout << setw(5) << x << setw(10) << f(x) << endl;
	}

}

void main()
{
	Tab("sin", sin);
}

/*
  VZNAM MANIPULTOR:
  setw(n): kolik znak m nsledujc vstup zabrat.
  fixed: formt s pevnou dovou tekou vdy.
  setprecision: Je-li nastaveno fixed, je to poet desetinnch mst, jinak celkov poet
  platnch cifer.
  endl: okamit vypi pipraven vstup a pejdi na novou dku.
  showpoint: zobrazuj desetinnou teku, i kdy je zbuten.
*/