// Soubor IO7.CPP
// Pouit pamovch proud pi analze pkazov dky programu
//
// Program me mt v pkazov dce pepnae -a, -r a -v v libovolnm poad
// postup nanlzy pkazov dky: 
// - pro kad z parametr (krom nultho, kde je jmno programu) vytvome vstupn pamov proud
// - Peteme z nj jeden znak nen-li to '-', ignoruje se
// - Je-li to '-', pete se dal znak. Ten se pak porovn s polem symbols znak pepna
//   a podle toho, kolikt je, se nastav odpovdajc hodnota v poli settings
//
// Nakonec program vytvo vstupn proud, v nm zformtuje etzec kajc,
// jak nastaven program v pkazov dce nael, a vypie je.

#include <sstream>
#include <iostream>

using namespace std;

const int N = 3;

bool settings[N] = {false,};		// Pole uchovvajc zadan nastaven
char symbols[N] = {'a', 'r', 'v'};	// pole symbol pro jednotliv nastaven

void main(int argc, char** argv)
{
	for(int i = 1; i < argc; i++)
	{
		char c; 
		istringstream S(argv[i]);	// Vytvo proud pro i-t parametr programu
		S >> c;				// Peti znak
		if(c != '-') break;		// nen-li to '-', jdi na dal
		S >> c;				// Peti dal znak
		for(int j = 0; j < N; j++)	// Vyhledej ho v poli symbols
			if(c == symbols[j])	// a a ho najde, zapi do odpovdajcho prvku pole 
			{			// settings hodnotu true
				settings[j] = true; 
				break; 
			}
	}
	// Vpis petench nastaven
	ostringstream T;			// Vytvo vstupn proud, vlo bdo nj zkladn hlen
	T << "Pouzita nastaveni: ";		// a pipoj symboly zadanch nastaven
	for(int j= 0; j < 3; j++)
		if(settings[j]) T << symbols[j];
	cout << T.str();			// Vypi obsah proudu na standardn vstup

}