// Soubor IO8.CPP
// Nejjednodu uivatelsk definice opertor >> a << pro vstup a vstup
//
// V programu je definovna tda cplx reprezentujc komplexn sla.
// Opertor << m na starosti vstup komplexnch sel ve tvaru (a, b),
// opertor >> te komplexn slo jako dvojoci relnch sel oddlench mezerou
//
// Pozor: MS Visual C++ 6.0 tento program nepelo, hls "nejednoznan opertory"
// a "nedovolen pstup k soukromm slokm tdy cplx". (Deklaraci friend bere 
// jako deklaraci jin funkce ne jsou nsledujc deklarace opertor)
// Jde zejm o chybu pekladae.

#include <iostream>

using namespace std;

class cplx {
	double re;
	double im;
public:
	double Re(){ return re;};
	double Im(){ return im;};
	cplx(double re=0, double im=0):re(re), im(im){};
	friend ostream& operator<<(ostream& Proud, cplx& c);
	friend istream& operator>>(istream& Proud, cplx& c);
};

// Vstupn opertor << MUS mt prvn parametr typu istream& (pedvan odkazem)
// a MUS vracet pedan proud odkazem.
istream& operator>>(istream& Proud, cplx& c)
{
	return  Proud >> c.re >> c.im;
}

// Vstupn opertor >> MUS mt prvn parametr typu ostream& (pedvan odkazem)
// a MUS vracet pedan proud odkazem.
ostream& operator<<(ostream& Proud, cplx& c)
{
	return Proud << "(" << c.re << ", " << c.im << ")";
}

/*
// vylepen verze opertoru <<
ostream& operator<<(ostream& Proud, cplx& c)
{
 int j = Proud.width();      // Zjistmne nastavenou ku
 Proud << setw(0);           // implicitn ka
 j = (j-4)/2;                // Rozpotme ku na ob sloky
 if (j<0) j = 0;
 return Proud << "(" << setw(j) << c.re << ", " << setw(j) << c.im << ")";
}
*/
void main()
{	// Njak banln pouit...
	cplx c(1,2);
	cout << c << endl;
	cin >> c;
	cout << setw(10) << c;
	
}

