// Soubor STL02.CPP
// Ukzka pouit funknho objektu pi tdn dvoustrann fronty.
//
// Program vytvo d - przdnou dvoustrannou frontu (deque) pro cel sla.
// Do d pak ulo sla 0, -1, 2, -3, ... -9 (sla od 0 do 9 se stdavmi znamnky).
// K tomu pouije metody d.push_back().
// Pak obsah d vype. Protoe vme, kolik sel ve front je, 
// mohli bychom pout opertor indexovn. Bezpenj je ale funkce at(),
// kter v ppad, e pouijeme chybn index, vyvol vjimku.
//
// Dle pouijeme na d knihovn funkci sort(), kter jako parametry pedme
// itertory d.begin() a d.end(), kter ukazuj NA prvn a ZA posledn prvek.
// Vsledek vypeme.
//
// Pak na d pouijeme jet jednou sort(), kter ale jako tet parametr
// pedme instanci tdy Comp. Tato tda zapouzduje opertor <
// (nebo pesnji relaci a < b).
// Ve skutenosti neobsahuje nic jinho ne peten opertor voln
// funkce se dvma parametry a vrac true, resp. false podle toho,
// zda je prvn parametr men nebo vt ne druh.
// PRAVAMI TDY Less MَEME SNADNO MNIT KRITRIUM TDN.
//
// Vsledek opt vypeme.
//
// Zkuste si rzn mnit metodu Comp::operator()() a tm mnit kritrium tdn.

#include <deque>
#include <iostream>
#include <algorithm>
#include  <stdlib.h>
#include <conio.h>

using namespace std;

class Comp	// Tda zapouzdujc opertor relaci "a < b"
{
  public: bool operator()(int a, int b)
  {
       return abs(a) > abs(b);
  }
};

// Vpis fronty v zadanm rozmez index
void vypis(deque<int>& D, int I, int J)
{
 try {
     for(int i = I; i < J; i++)
         cout << D.at(i) << " ";
     cout << endl;
 }
 catch(...) {}
}

void main()
{
 deque<int> d;		// Vytvo przdnou frontu
 for(int i = 0, j = 1;	// vypl ji sly 0, -1, 2, -3, 4, -5...
         i < 10;
	 i++, j = -j)
         d.push_back(i*j);

 vypis(d, 0, 10);  // Vypi prvnch 10 prvk fronty

 sort(d.begin(), d.end());	// Uti pomoc standardnho porovnn

 vypis(d, 0, 10);

 sort(d.begin(), d.end(), Comp()); // Uti podle pomoc Comp

 vypis(d, 0, 10);

 getch(); // Kvli spoutn v prosted C++ Builderu
}

/* Tento program vype

0 -1 2 -3 4 -5 6 -7 8 -9
-9 -7 -5 -3 -1 0 2 4 6 8
-9 8 -7 6 -5 4 -3 2 -1 0

*/