// Soubor CPLX.CPP
// Pklad deklarace objektovho typu bez pedk

#include <math.h>
class cplx {				// Hlavika tdy
	double re, im;			// Soukrom datov sloky (atributy)
public:					// Nsledujc sloku budou veejn
	double Re();			// Metody
	double Im();
	cplx Plus(cplx b);
	void NastavRe(double d) {re = d; }
	cplx(double r=0, double i=0);
	friend double Abs(cplx &c) {return sqrt(c.re * c.re + c.im*c.im);}
};

cplx::cplx(double r, double i)		// Konstruktor
: re(r), im(i) 				// inicializan st konstruktoru
{}

double cplx::Im() { return im; }	
double cplx::Re() { return re; }

/*
// Nepli elegantn zpsob
// jak stat komplexn sla
cplx cplx::Plus(cplx b)
{
  cplx c;
  c.re = re + b.re;
  c.im = im + b.im;
  return c;
}
*/

cplx cplx::Plus(cplx b)			// Lep definice metody pro stn
{
  return cplx(re+b.re, im+b.im);
}

void main()
{
	cplx C(1,1), D, E(1,5);		// Deklarace instanc znamen voln konstruktoru
    double d = Abs(C);
	D = C.Plus(E);
	C.NastavRe(11.3);
}