/* Soubor SOUBOR.H
	Definice typu Soubor, kter zapouzduje binrn soubor pro ukldn 
	grafickch objekt. Vyuv prostedky pevzat z jazyka C (pat 
	ke 4. kapitole a zde jsme jet neprobrali objektov datov proudy).

    - Metoda operator<<(GO&) je univerzln, slou k ulkldn typu GO a 
	  vech jeho potomk (pesnji pouze tch potomk, nebo typ GO je 
	  abstraktn). Vol metodu virtuln Uloz() ukldanho 
	  grafickho objektu.

    - Metoda operator<<(int) je pomocn, slou k ukldn sloek grafickch 
	  objekt, kter jsou vechny celoseln.

*/

#ifndef _SOUBOR_H_
 #define _SOUBOR_H_

#include <stdio.h>

class GO;

void chyba(char* co);

class Soubor {
  FILE* f;
  char jmeno[100];	// Jmno souboru
  // Nsledujc dv deklarace zabrn koprovn instanc
  // Odpovdajc metody nedefinujeme
  Soubor& operator=(Soubor&);
  Soubor(Soubor&);
public:
  Soubor& operator<<(int i);	// Zpis celch sel
  enum zpusob {cteni, zapis, pripisovani}; // Zpsob oteven souboru
  Soubor(char* jm);
  int Otevri(zpusob);
  void Zavri();

  Soubor& operator<<(GO&);		// Zpis typu GO a jeho potomk
};
#endif