// Soubor T_MAX.CPP
// vodn pklad deklarace ablony: 
// ablona funkce MAX, kter vypote vt ze dvou hodnot.
#include <iostream.h>

// Definice ablony
template<class T> T MAX(T a, T b)
{
	return a > b? a : b;
};

// Tda, pro kterou je definovn opertor >
class Int {
	int i;
public:
	Int(int j):i(j){}
	int hodnota(){ return i;}
	friend bool operator>(Int a, Int b);
};

bool operator>(Int a, Int b)
{
	return a.i > b.i;
}

void main()
{
	int a = 11, b = 22;
	char alfa('a'), beta('b'); // znamen tot jako  char alfa = 'a', beta ='b';
	Int x(5), y(6);
	// Pouit ablony: Peklada automaticky vytvo instance
	// ablony Max, tj. funkce 
	// int MAX(int, int), char MAX(char, char) a Int MAX(Int, Int)
	cout << MAX(a, b) << endl;
	cout << MAX(alfa, beta) << endl;
	cout << MAX(x, y).hodnota() << endl;
	// To nejde - peklada nev, co s tm:
	// cout << MAX(a, beta);

	// Musme pekladai napovdt, jakou instanci vlastn chceme:
	// (Ani to nemus ve starch pekladach fungovat.)
	cout << MAX<int>(a, beta);
}	