// Soubor CCAST1.CPP
// pklad na pouit opertoru const_cast
//
// Deklarujeme tdu D, kter obsahuje metodu hodnota, a to jak 
// variantu pro konstantn instance, tak variantu pro nekonstantn instance.
// (To C++ dovoluje.)
// Opertor const_cast pouijeme k tomu, abychom pro nekonstantn instanci zavolali
// metodu urenou pro konstantn instance
//

#include <iostream>
using namespace std;

class D {
	int d;
public:
	D(int d): d(d){}
	int hodnota() const {
		cout << "Vola se metoda pro konstantni instance" << endl;
		return d;
	}
	int hodnota() {
		cout << "Vola se metoda pro nekonstantni instance" << endl;
		return d;
	}
};

void main()
{
	const D d1(5);
	D d2(6);
	d1.hodnota();					// Zavol se metoda hodnota() const;
	const_cast<D&>(d1).hodnota();	// Zavol se metoda hodnota();
	d2.hodnota();					// Zavol se metoda hodnota();
	const_cast<const D&>(d2).hodnota();// Zavol se metoda hodnota() const;
}