// Soubor RCAST1.CPP
// pklad na pouit opertoru reinterpret_cast
// deklarovan tdy jsou stejn jako v souboru DCAST1.CPP
//
#include <typeinfo>					// Viz soubor DCAST.CPP na WWW
#include <iostream>
using namespace std;
class A {									// Pedek
	int a;
public:
	A(int i): a(i){}
	virtual ~A() {}						// Potebujeme virtuln metodu
	int hodnota() { return a; }
};
class B {									// Dal, nezvisl pedek
	int b;
public:
	B(int i): b(i){}
	virtual ~B() {}
	int hodnota() { return b; }
};
// C je spolenm (jednoznanm a pstupnm) potomkem A a B
class C: public A, public B
{
	int c;
public: 
	C(int c): A(c), B(c+1), c(c+2) {}
	int hodnota() { return c; }
};
A a(1); 					// Instance
B b(2);
C c(3); 					// c.a == 3, c.b == 4, c.c == 5
A* ua;						// Ukazatele na instance
B* ub;
C* uc = &c; 

void f(B& b)				// Funkce f oekv parametr typu B
{
	cout << b.hodnota(); 
}

void main()
{
	ua = &a;

// Jin interpretace ukazatele
	ub = reinterpret_cast<B*>(ua);	// Ukazatel na a interpretovan jako ukazatel na instanci tdy B
	cout << ub ->hodnota() << endl;	// Vype 1, nebo tdy A a B maj NATST STEJNOU VNITN STRUKTURU

// Petypovn instance
	f(reinterpret_cast<B&>(a));		// A a B maj stejnou strukturu, take se meme pedat A 
									// na mst, kde se oekv B, pokud ho petypujeme
}									// Vype opt 1