// Soubor IO3.CPP
// ten celch sel ze souboru neznm velikosti
// Pouijeme proud ifstream (konstruktor m sice 3 parametry, 
// musme ale zadat pouze prvn - jmno souboru).
//
// K testovn pouijeme peten opertor petypovn na void*,
// kter vrt 0, kdy se posledn operace nepoda

#include <iostream>
#include <fstream>
#include <stdlib.h>

using namespace std;

const char* jmeno = "data.dta";

void Chyba()
{
	cerr << "nepodailo se otevt soubor " << jmeno << endl;
	exit(1);
}

void main()
{
	ofstream F(jmeno);
	if(F)	{									// Pokud se soubor podailo otevt...
		for(int j = 0; j < 10; i++)
			F << j << "  " << endl<< endl;		
		F.close();
	}
	else Chyba();

	ifstream G(jmeno);
	int i;
	while(G >> i)
	{
		cout << i << endl;
	}
}