// Soubor IO6.CPP
// Vstup do pamovho proudu
//
// Ve funkci main() vytvome proud ostringstream (konstruktor je bez parametr)
// a tento proud pedme jako parametr funkci Tab()
// Funkce Tab() se nezmnila, je stejn jako v IO2.CPP
// Pos skonen vstupu meme data z tohoto proudu zskat
// nap. pomoc metody str(), kter vrt instanci typu string
// tu lze nap. vypsat do standardnho vstupu pomoc opertoru <<

#include <iomanip>
#include <iostream>
#include <sstream>
#include <math.h>
#include <stdlib.h>

using namespace std;

void Chyba(){ // Primitivn oeten chyby: hlen a konec programu
	cerr << "Nejde otevrit soubor" << endl;
	exit(0);
}

void Tab(ostream& Proud, const char* s, double (*f)(double))
{
	Proud << "Tabulka funkce " << s << endl;
	Proud << "-------------------" << endl;
	Proud << setw(5) << "x" << setw(8) << s << "(x)" << endl;
	Proud << "-------------------" << endl;
	Proud << setprecision(5) << fixed << showpoint;
	for(int i = 0; i <= 10; i++)
	{
		double x = i/10.0;
		Proud << setw(5) << x << setw(10) << f(x) << endl;
	}

}

void main()				// Viz soubor IO6.CPP na WWW
{
	ostringstream S;	// Vytvo proud a otevi soubor
	if(!S)					// Pokud se to nepoda, volej chybovou funkci
	  Chyba();
	
	Tab(S, "sin", sin);// Proud jako parametr funkce
	cout << S.str() << endl;
}

